package Loove 
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	
	import net.flashpunk.tweens.misc.NumTween;
	import net.flashpunk.utils.Ease;
	
	public class Instruction extends Entity
	{
		[Embed(source = '../../assets/Loove_370x600_Intro_v2.png')] private const INSTRUCTION:Class;
		
		private var fader:NumTween = new NumTween(faderEnd);
		public var completed:Boolean = false;
		
		private var mImage:Image = new Image(INSTRUCTION);
		
		public function Instruction() 
		{
			graphic = mImage;
			
			addTween(fader);
			fader.value = 1;
		}
		
		override public function update():void 
		{
			// Fade in/out alpha control.
			mImage.alpha = fader.value;
		}
		
		/**
		 * Fades the splash screen in.
		 * @param time	The time the transition will need.
		 */
		public function fadeIn(time:Number=1):void
		{
			fader.tween(fader.value, 1, time, Ease.cubeOut);
			completed = false;
		}
		
		/**
		 * Fades the splash screen out.
		 * @param time	The time the transition will need.
		 */
		public function fadeOut(time:Number=1):void
		{
			fader.tween(fader.value, 0, time, Ease.cubeIn);
			completed = false;
		}
		
		/**
		 * Executes when the fade in/out has finished.
		 */
		private function faderEnd():void 
		{
			completed = true;
		}
	}
}