package Loove 
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.FP;
	
	public class Obstacle extends Entity
	{
		[Embed(source = '../../assets/Loove_Obstacle_Triangle_v2.png')] private const OBSTACLE0:Class;
		[Embed(source = '../../assets/Loove_Obstacle_Rectangle_1_v2.png')] private const OBSTACLE1:Class;
		[Embed(source = '../../assets/Loove_Obstacle_Rectangle_2_v2.png')] private const OBSTACLE2:Class;
		[Embed(source = '../../assets/Loove_Obstacle_Square_v2.png')] private const OBSTACLE3:Class;
		[Embed(source = '../../assets/Loove_Obstacle_TwinTriangle_v1.png')] private const OBSTACLE4:Class;
		[Embed(source = '../../assets/Loove_Obstacle_TwinTriangle_v2.png')] private const OBSTACLE5:Class;
		
		static private const OBSTACLE_BASE_SPEED:Number = 40;
		private var mObstacleVariableSpeed:Number = 0;
		static private const OBSTACLE_VARIABLE_ACC:Number = 0.2;
		static private const OBSTACLE_SEC_PER_CYCLE:Number = 3;
		private var obstacleSpeedPhase:Number = 0;
		private var obstacleSpeed:Number = 40;
		 
		public function Obstacle(obstType:int) 
		{
			var image:Image;
			if (obstType == 0)
			{
				image = new Image(OBSTACLE0);
			}
			else if (obstType == 1)
			{
				image = new Image(OBSTACLE1);
			}
			else if (obstType == 2)
			{
				image = new Image(OBSTACLE2);
			}
			else if (obstType == 3)
			{
				image = new Image(OBSTACLE3);
			}
			else if (obstType == 4)
			{
				image = new Image(OBSTACLE4);
			}
			else if (obstType == 5)
			{
				image = new Image(OBSTACLE5);
			}
			graphic = image;
			
			if (obstType == 0)
			{
				image.x = -19;
				image.y = -2;
				setHitbox(image.width - 40, image.height - 31);
			}
			else
			{
				image.x = -2;
				image.y = -2;
				setHitbox(image.width - 4, image.height - 4);
			}
			type = "obstacle";
		}
		
		override public function added():void
		{
			mObstacleVariableSpeed = 0;
		}
		
		override public function update():void
		{
			updatePos();
		}
		
		private function updatePos():void
		{
			obstacleSpeedPhase += (1 / OBSTACLE_SEC_PER_CYCLE) * 2 * Math.PI * FP.elapsed;
			if (obstacleSpeedPhase > 2 * Math.PI)
			{
				obstacleSpeedPhase -= 2 * Math.PI;
			}
			mObstacleVariableSpeed += OBSTACLE_VARIABLE_ACC * FP.elapsed;
			obstacleSpeed = OBSTACLE_BASE_SPEED + 
			mObstacleVariableSpeed * Math.sin(obstacleSpeedPhase)
			y += obstacleSpeed * FP.elapsed;
		}
	}
}